import 'dart:io';
import 'dart:math';

import 'package:flutter/material.dart';
import 'dart:async';
import 'package:image_picker/image_picker.dart';
import 'package:flutter/services.dart';
import 'package:flutter_aly_oss/flutter_aly_oss.dart';
import 'package:uuid/uuid.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _platformVersion = 'Unknown';
  final _uuid = Uuid();
  @override
  void initState() {
    super.initState();
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  init() async{
     final FlutterAlyOss _alyOss = FlutterAlyOss();
       var result = await _alyOss.init(InitRequest(
       _uuid.v4(),
       'https://ottoapi.niuniutaojin.com/get-security-token',
       'oss-cn-shanghai.aliyuncs.com',
       '',
       ''));
  }

  Future pickerAndUpload({ImageSource type:ImageSource.gallery, String key: 'attachment/'}) async {
    File _image;
    if(type == ImageSource.gallery){
      final pickedFile = await ImagePicker().getImage(source: ImageSource.gallery);
      _image = File(pickedFile.path);
    }else if(type == ImageSource.camera){
      final pickedFile = await ImagePicker().getImage(source: ImageSource.camera);
      _image = File(pickedFile.path);
    }else {

    }
    print('pickerAndUpload');
    return await upload(_image,key);
  }

  Future upload(File image, [String key = 'attachment/']) async {
    if (image != null) {
      String str = '${DateTime.now().millisecondsSinceEpoch}${getRandomAlphanumeric()}.jpg';
      print('str:${image.absolute.path}');
      print('str:$str');
     await FlutterAlyOss().upload(UploadRequest(
         _uuid.v4(),
         'future-lenoir-bucket',
         '${key}${str}',
         image.absolute.path));
      return Future.value({'image': ''});
    }
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
        appBar: AppBar(
          title: const Text('Plugin example app'),
        ),
        body: Center(
          child:  Column(
            children: [
              TextButton(
                  onPressed: () {
                    init();
                  },
                  child: Text('setup（初始化）',style: TextStyle(fontSize: 18.0))
              ),
              TextButton(
                  onPressed: () {
                    pickerAndUpload();
                  },
                  child: Text('上传图片）',style: TextStyle(fontSize: 18.0))
              )
            ],
          ),
        ),
      ),
    );
  }

  static String getRandomAlphanumeric({strLength = 6}) {
    String alphabet =
        '0123456789qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM';
    String left = '';
    for (var i = 0; i < strLength; i++) {
//    right = right + (min + (Random().nextInt(max - min))).toString();
      left = left + alphabet[Random().nextInt(alphabet.length)];
    }
    return left;
  }
}

